# frozen_string_literal: true

module VG
  module SO
    module ServiceObjectModuleInheritance

      module ClassMethods
        def included(base)
          puts "-- #{self.name}#included call (including into #{base})"
          InjectRegistrationMethods.call(base)
          base.register_service_objects(registered_service_objects)
          
          super(base)
        end
      end

      def self.included(base)
        return unless base.instance_of?(Module)
        return if base.singleton_class.included_modules.include?(ClassMethods)

        puts "-- prepend #{base.name}#included with ServiceObjectModuleInheritance#included"
        base.singleton_class.prepend ClassMethods
      end

    end # ... ServiceObjectModuleInheritance
  end # ... SO
end # ... VG
